package ru.ulstu.admin.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import ru.ulstu.admin.model.ReportForm;
import ru.ulstu.admin.service.AdminReportService;

import java.util.List;

@Controller
@RequestMapping("/admin")
public class AdminReportController {

    private final AdminReportService adminReportService;

    public AdminReportController(AdminReportService adminReportService) {
        this.adminReportService = adminReportService;
    }

    @GetMapping("/report/{aspirantId}")
    public String getReportForm(@PathVariable(value = "aspirantId") Integer aspirantId, Model model) {
        ReportForm reportForm = new ReportForm();
        reportForm.setAspirantId(aspirantId); // Устанавливаем ID аспиранта
        model.addAttribute("report", reportForm);
        return "admin/aspirantReport"; // Возвращает шаблон report.html
    }

    @PostMapping("/saveReport")
    public String saveReport(@ModelAttribute ReportForm reportForm,
                             @RequestParam("file") List<MultipartFile> files) {
        // Сохраняем отчет
        adminReportService.saveReport(reportForm);

        // Обработка загруженных файлов
        if (!files.isEmpty()) {
            for (MultipartFile file : files) {
                System.out.println("Файл: " + file.getOriginalFilename());
                // Здесь можно добавить логику сохранения файла на сервере
            }
        }

        return "redirect:/admin/aspirants"; // Перенаправление на список аспирантов
    }
}